<?php
/**
* フィルタを生成するファクトリクラス
*
* PHP version 5
*
* @package    core
* @author     stk2k <stk2k@sazysoft.com>
* @copyright  2008 stk2k, sazysoft
*/

class charcoal_FilterFactory 
{
	/*
	 * フィルタを作成
	 */
	public static function create( $filter_name )
	{
		log_info( "system",  "フィルタ[$filter_name]をロードします。", __FILE__, __LINE__ );

		// FilterConfigをロード
		$config = charcoal_ConfigLoader::loadConfig( $filter_name, 'filter' );

		// クラス名を取得
		$class_name = $config->getString( 'class_name' );

		// フィルタのインスタンス生成
		$filter = charcoal_ClassUtil::newInstance( $class_name );

		// 生成したインスタンスがIFilterインタフェースを実装しているか確認
		if ( !($filter instanceof charcoal_IFilter) ){
			// 実装例外
			throw new charcoal_InterfaceImplementException( $class_name, "charcoal_IFilter" );
		}

		log_info( "system",  "フィルタ[$filter_name]を初期化します。", __FILE__, __LINE__ );

		// フィルタを初期化
		$filter->init( $config );

		log_info( "system",  "フィルタ[$filter_name]をロードしました。", __FILE__, __LINE__ );

		// ロードしたフィルタを返却
		return $filter;
	}
}
